# coding: utf-8

"""
    Daytona Workspaces

    Daytona Workspaces API Docs

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from daytona_api_client.models.file_status import FileStatus
from typing import Optional, Set
from typing_extensions import Self

class GitStatus(BaseModel):
    """
    GitStatus
    """ # noqa: E501
    current_branch: StrictStr = Field(alias="currentBranch")
    file_status: List[FileStatus] = Field(alias="FileStatus[]")
    ahead: Optional[Union[StrictFloat, StrictInt]] = None
    behind: Optional[Union[StrictFloat, StrictInt]] = None
    branch_published: Optional[StrictBool] = Field(default=None, alias="branchPublished")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["currentBranch", "FileStatus[]", "ahead", "behind", "branchPublished"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GitStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in file_status (list)
        _items = []
        if self.file_status:
            for _item_file_status in self.file_status:
                if _item_file_status:
                    _items.append(_item_file_status.to_dict())
            _dict['FileStatus[]'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GitStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "currentBranch": obj.get("currentBranch"),
            "FileStatus[]": [FileStatus.from_dict(_item) for _item in obj["FileStatus[]"]] if obj.get("FileStatus[]") is not None else None,
            "ahead": obj.get("ahead"),
            "behind": obj.get("behind"),
            "branchPublished": obj.get("branchPublished")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


