# coding: utf-8

"""
    Daytona Workspaces

    Daytona Workspaces API Docs

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from daytona_api_client.models.workspace_info import WorkspaceInfo
from typing import Optional, Set
from typing_extensions import Self

class Workspace(BaseModel):
    """
    Workspace
    """ # noqa: E501
    id: StrictStr = Field(description="The ID of the workspace")
    name: StrictStr = Field(description="The name of the workspace")
    image: StrictStr = Field(description="The image used for the workspace")
    user: StrictStr = Field(description="The user associated with the project")
    env: Dict[str, StrictStr] = Field(description="Environment variables for the workspace")
    labels: Dict[str, StrictStr] = Field(description="Labels for the workspace")
    public: StrictBool = Field(description="Whether the workspace http preview is public")
    target: StrictStr = Field(description="The target environment for the workspace")
    info: Optional[WorkspaceInfo] = Field(default=None, description="Additional information about the workspace")
    cpu: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The CPU quota for the workspace")
    gpu: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The GPU quota for the workspace")
    memory: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The memory quota for the workspace")
    disk: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The disk quota for the workspace")
    state: Optional[StrictStr] = Field(default=None, description="The state of the workspace")
    error_reason: Optional[StrictStr] = Field(default=None, description="The error reason of the workspace", alias="errorReason")
    snapshot_state: Optional[StrictStr] = Field(default=None, description="The state of the snapshot", alias="snapshotState")
    snapshot_created_at: Optional[StrictStr] = Field(default=None, description="The creation timestamp of the last snapshot", alias="snapshotCreatedAt")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "name", "image", "user", "env", "labels", "public", "target", "info", "cpu", "gpu", "memory", "disk", "state", "errorReason", "snapshotState", "snapshotCreatedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Workspace from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of info
        if self.info:
            _dict['info'] = self.info.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Workspace from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "image": obj.get("image"),
            "user": obj.get("user"),
            "env": obj.get("env"),
            "labels": obj.get("labels"),
            "public": obj.get("public"),
            "target": obj.get("target"),
            "info": WorkspaceInfo.from_dict(obj["info"]) if obj.get("info") is not None else None,
            "cpu": obj.get("cpu"),
            "gpu": obj.get("gpu"),
            "memory": obj.get("memory"),
            "disk": obj.get("disk"),
            "state": obj.get("state"),
            "errorReason": obj.get("errorReason"),
            "snapshotState": obj.get("snapshotState"),
            "snapshotCreatedAt": obj.get("snapshotCreatedAt")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


